<?php

namespace Drupal\json_users_import\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Component\Serialization\Json;
use Drupal\json_users_import\Controller\JsonUsersImportController;

/**
 * Provides a form to import the users from Json
 */
class JsonUsersImport extends FormBase {
	
	/**
	 * Implements \Drupal\Core\Form\FormInterface::getFormID().
	 */
	public function getFormId() {
		return 'json_users_import_form';
	}

	/**
   * {@inheritdoc}
   */
	public function buildForm(array $form, FormStateInterface $form_state) {
		
		$form['user_import'] = [
      '#title' => $this->t('Paste your json here'),
      '#type' => 'textarea',
      '#rows' => 24,
      '#required' => TRUE,
    ];
    
    $form['actions'] = ['#type' => 'actions'];
    $form['actions']['submit'] = [
      '#type' => 'submit',
      '#value' => $this->t('Import'),
      '#button_type' => 'primary',
    ];
		return $form;
	}

	/**
   * {@inheritdoc}
   */
	public function validateForm(array &$form, FormStateInterface $form_state) {

	}

	/**
   * {@inheritdoc}
   */
	public function submitForm(array &$form, FormStateInterface $form_state) {
		$users_json = $form_state->getValue('user_import');
		$json_decoded = Json::decode($users_json);
		if(is_array($json_decoded)) {
			$operations = [['creating_users_batch', [$json_decoded]]];
      $batch = [
        'title' => $this->t('Creating Users ...'),
        'operations' => $operations,
        'finished' => 'users_finished_batch',
      ];
      batch_set($batch);
		} else {
			\Drupal::messenger()->addMessage("Not a valid Json!");
		}
	}
}